{{ $appSection := "sshd" -}}
{{ $appName := (index . "Values" $appSection "name") -}}
{{- if index . "Values" $appSection "enabled" -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ $appName }}
  labels:
    app.kubernetes.io/name: {{ $appName }}
    {{- include "golemio.labels" . | nindent 4 }}
  annotations:
    rollme: {{ .Values.configurationFiles.sshdKeys | toYaml | sha256sum | trunc 8 | quote }}
    {{- include "golemio.annotations" . | nindent 4 }}
spec:
  replicas: 1
  strategy: {{- include "golemio.rollingUpdate" (index . "Values" $appSection) | nindent 4 }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ $appName }}
      {{- include "golemio.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ $appName }}
        {{- include "golemio.labels" . | nindent 8 }}
        {{- if (index . "Values" $appSection "podLabels") }}
        {{- include "common.tplvalues.render" ( dict "value" (index . "Values" $appSection "podLabels") "context" $ ) | nindent 8 }}
        {{- end }}
      annotations:
        checksum/config: {{ include (print $.Template.BasePath "/" $appName "-configmap.yaml") . | sha256sum }}
        {{- include "golemio.annotations" . | nindent 8 }}
        {{- if (index . "Values" $appSection "podAnnotations") }}
        {{- include "common.tplvalues.render" ( dict "value" (index . "Values" $appSection "podAnnotations") "context" $ ) | nindent 8 }}
        {{- end }}
    spec:
      automountServiceAccountToken: false
      containers:
        - name: {{ .Values.sshd.name }}
          image: {{ include "golemio.imageName" (list . $appSection) | quote }}
          imagePullPolicy: {{ .Values.global.pullPolicy }}
          volumeMounts:
          - name: {{ $appName }}-config
            mountPath: /root/.ssh/authorized_keys
            subPath: authorized_keys
            readOnly: true
          resources:
            {{ index .Values $appSection "resources" | toYaml | nindent 12 }}
          securityContext:
            allowPrivilegeEscalation: false
      volumes:
      - name: {{ .Values.sshd.name }}-config
        configMap:
          name: {{ .Values.sshd.name }}-config
          items:
            - key: authorized_keys
              path: authorized_keys
{{ end }}
